<!-- This template is used to render live previews in both review apps and about.gitlab.com -->
<script lang="ts">
import NextStepAlt from '~/components/common/next-step-alt.vue';
import { LivePreviewMixin } from '~/mixins';
import { CtfCustomPage, CtfEntry } from '~/models';
import { ContentfulLivePreview } from '@contentful/live-preview';
import * as ContentfulComponents from '~/components/contentful/index.vue';
import SlpNavigationHOC from '~/components/navigation/navigation-hoc.vue';
import NavBanner from '~/components/navigation/nav-banner.vue';
import SlpFooterHOC from '~/components/navigation/footer-hoc.vue';
import { init, refresh } from 'aos';
import { getPageMetadata } from '~/common/meta';

export default {
  components: {
    SlpFooterHOC,
    NavBanner,
    SlpNavigationHOC,
    NextStepAlt,
    ...ContentfulComponents,
  },
  nuxtI18n: false,
  mixins: [LivePreviewMixin],
  data() {
    return {
      contentfulData: null,
      sideNavigation: null,
    };
  },
  // We can't fetch serverside as this page will render content that is still in draft state.
  fetchOnServer: false,
  async fetch() {
    const id = this.$route.query.id;
    const config = {
      accessToken: this.$config.preview,
      space: this.$config.space,
      host: 'preview.contentful.com',
    };
    try {
      const contentfulData: CtfEntry<CtfCustomPage> =
        await this.$contentfulService.getCustomPagePreview(id, config);

      this.contentfulData = contentfulData;

      if (this.contentfulData.fields.components) {
        this.sideNavigation = this.$contentfulService.mapSideNavigation(
          this.contentfulData.fields.components,
        );
      }
    } catch (e) {
      throw new Error(e);
    }
  },
  head() {
    try {
      const metadata = {
        ...(this.contentfulData?.fields?.seoMetaData?.fields || {}),
        noIndex: true,
      };
      return getPageMetadata(metadata, this.$route.path);
    } catch (e) {
      throw new Error(e);
    }
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.contentfulData,
        callback: (updatedData) => {
          this.contentfulData = updatedData;
          if (this.contentfulData.fields.components) {
            this.sideNavigation = this.$contentfulService.mapSideNavigation(
              this.contentfulData.fields.components,
            );
          }
        },
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
    refresh();
  },
  beforeMount() {
    init({
      once: true,
    });
  },
};
</script>

<template>
  <div>
    <!--Contentful Content Start-->
    <SlpContainer v-if="contentfulData">
      <Hero :data="contentfulData.fields" />
      <template v-if="contentfulData.fields.activateSideMenu && sideNavigation">
        <SlpSideNavigation :data="sideNavigation">
          <section
            v-for="(component, i) in contentfulData.fields.components"
            :key="i"
          >
            <component
              :is="component.fields.componentName"
              :data="component.fields"
            />
          </section>
        </SlpSideNavigation>
      </template>
      <template v-else>
        <section
          v-for="(component, i) in contentfulData.fields.components"
          :key="i"
        >
          <component
            :is="component.fields.componentName"
            :data="component.fields"
          />
        </section>
      </template>
      <NextStepAlt />
    </SlpContainer>
  </div>
</template>
